﻿/**
 * 
 */
var mX=0,mY=0;
var tapping=false;

var statements=[];
var divHoveringIndex=-1;
var divSrcIndex=-1;
var divDestinationIndex=-1;
var xOffset=0;
var yOffset=0;
var slotHeight=0;
var statementsTopBorder;

function initialise(){
	$("#number-A").val(varValues[0]);
	simulating=false;
	simulatingBackwards=false;
	visibleCases=Math.pow(2,noOfCases)-1;
	codeLeftBorder=$(document).width()/2+verticalBorder;
	codeTopBorder=$("#buttonArea").outerHeight();
	
	generateSolutionExpressions();
	showAppTitle();
	showButtonCaptions();
	showProblem();
	promptTopBorder=codeTopBorder+$("#problemWording").outerHeight()+verticalBorder;
	adjustCode();
	defineConditionalsArray();
	//$(".movableDIV").hide();
	
	$("#solutionControls").hide();
	$("#simulateControls").hide();
	$("#algorithmStart").hide();
	$("#algorithmEnd").hide();
	$("#dataInput").hide();
	initialiseEvents();
	showPrompt();
	adjustCode();
	showStatements();
	$(".varLabel").css("text-align","center");
}

function initialiseEvents(){
	//mouse events
	document.addEventListener("mousedown", function(evt){
		handleMouseDown();
	});
	document.addEventListener("mouseup", function(evt){
		mX=evt.pageX;
	 	mY=evt.pageY;
		handleMouseUp();
	});
	document.addEventListener("mousemove", function(evt){
	    mX=evt.pageX;
	    mY=evt.pageY;
		handleMouseMove();
	});
	
	$(".problemCases").hover(
		function(){
			if(visibleCases==Math.pow(2,noOfCases)-1){
				$("#part"+this.id.substr(4,1)).css({"background-color": "AntiqueWhite"});
			}
		},
		function(){
			if(visibleCases==Math.pow(2,noOfCases)-1){
				$("#part"+this.id.substr(4,1)).css({"background-color": "PaleGoldenRod"});
			}
		}
	);
	
	//touch events
	$("#showInfo").on("touchend",function(evt){
	    $("#showInfo").trigger("click");
	});
	
	/*document.addEventListener("touchstart",function(evt){
		evt.preventDefault();
		handleMouseMove();
		handleMouseDown();
    }, false);*/
	
	$(".problemCases").on("tap",function(){
		tapping=true;
		if(visibleCases==Math.pow(2,noOfCases)-1){
			for(var i=0;i<statements.length;i++){
				$("#part"+i).css({"background-color": "PaleGoldenRod"});
			}
			$("#part"+this.id.substr(4,1)).css({"background-color": "AntiqueWhite"});
		}
	});
	
	document.addEventListener("touchend",function(evt){
		if(tapping){
			tapping=false;
			return;
		}
		evt.preventDefault();
 		if(promptID<promptToRemoveConditionals){
 			var i=0;
 			mX=evt.changedTouches[0].pageX;
 			mY=evt.changedTouches[0].pageY;
 			if(divSrcIndex>-1){//έλεγχος σημείου απόθεσης
 				statements[divSrcIndex].release();
 				divDestinationIndex=-1;
 				i=0;
 	 	 	 	while(i<statements.length && divDestinationIndex==-1){
 	 	 	 		var inTarget=mX>$("#target"+i).position().left && mX<$("#target"+i).position().left+$("#target"+i).width();
 	 	 	 		inTarget=inTarget && mY>$("#target"+i).position().top && mY<$("#target"+i).position().top+$("#target"+i).height();
 	 	 	 		if (inTarget){
 	 	 	 			divDestinationIndex=i;
 	 	 	 		}
 	 	 	 		else{
 	 	 	 			i++;
 	 	 	 		}
 	 	 	 	}
 	 	 	 	if(divDestinationIndex>-1){
 	 	 	 		placeInSlot();
 	 	 	 	}
 	 	 		$.each($(".tapped"),function(){
 	 	 			$(this).removeClass("tapped");
 	 	 		});
 	 	 	 	divSrcIndex=-1;
 	 	 	 	divDestinationIndex=-1;
 			}
 			else{//έλεγχος σημείου επαφής για εντοπισμό επιλεγμένου statement
 	 	 		divSrcIndex=-1;
 	 	 		for(i=0;i<statements.length;i++){
 	 				$("#case"+statements[i].htmlID.substr(4,1)).css({"background-color": "#d1d1d1"});
	 				$("#part"+statements[i].htmlID.substr(4,1)).css({"background-color": "PaleGoldenRod"});
 	 	 		}
 	 	 		i=0;
 	 	 	 	while(i<statements.length && divSrcIndex==-1){
 	 	 	 		if (statements[i].mouseHover(mX,mY)){
 	 	 	 			xOffset=statements[i].left-mX;
 	 	 	 			yOffset=statements[i].top-mY;
 	 	 	 			divSrcIndex=i;
 	 	 	 		}
 	 	 	 		else{
 	 	 	 			i++;
 	 	 	 		}
 	 	 	 	}
 	 	 	 	if(divSrcIndex>-1){
 	 	 	 		$("#"+statements[divSrcIndex].htmlID).addClass("tapped");
 	 	 	 		$("#case"+statements[divSrcIndex].htmlID.substr(4,1)).css({"background-color": "AntiqueWhite"});
 	 	 	 	}
 			} 			
 		}
    }, false);
	/*document.addEventListener("touchmove",function(evt){
        evt.preventDefault();
		mX=evt.changedTouches[0].pageX;
		mY=evt.changedTouches[0].pageY;
		handleMouseMove();
    }, false);*/
	
	// Κουμπιά
    $("#btnPlay").on("click touchstart",function(){
    	simulating=true;
    	$("#btnPlay").hide();
    	$("#btnStop").show();
    	$("#btnPause").prop("disabled",false);
    	$("#btnBackward").prop("disabled",true);
    	$("#btnForward").prop("disabled",true);
    	simulatingBackwards=false;
		resetSimulation();
    	simulateCode(true);
    });
    
    $("#btnStop").on("click touchstart",function(){
    	simulating=false;
    	$("#btnPlay").show();
    	$("#btnStop").hide();
    	simulateCode(false);
    	resetSimulation();
    });
    
    $("#btnPause").on("click touchstart",function(){
    	simulating=false;
    	$("#btnPause").hide();
    	$("#btnContinue").show();
    	clearInterval(timerLoop);
    	handleContinuationButtons();
    });
    
    $("#btnContinue").on("click touchstart",function(){
    	simulating=true;
    	$("#btnContinue").hide();
    	$("#btnPause").show();
    	simulatingBackwards=false;
    	simulateCode(true);
    });
                
    $("#btnForward").on("click touchstart",function(){
    	if(simulationIndex==-1){
    		resetSimulation();//επαναφορά χρωμάτων μετά από εσφαλμένη συνθήκη
    	}
    	if(simulationIndex<endIfIndex+1){
    		simulatingBackwards=false;
    		simulateRun();
    	}
    	/*else{
    		resetSimulation();
    	}*/
    });
    
    $("#btnBackward").on("click touchstart",function(){
    	if(simulationIndex>-1){
			var trueStatementIndex=endIfIndex+2;
			if(simulationIndex<=ifIndex || simulationIndex>endIfIndex){
				simulationIndex-=2;
			}
			else{
				if($(".conditionTrue").first().attr("id")){
					var partID=parseInt($(".conditionTrue").first().attr("id").substr(7,1));
					partIndex=0;
					while(statements[partIndex].htmlID!="part"+partID){
						partIndex++;
					}
					trueStatementIndex=ifIndex+2*partIndex;
				}
				if(simulationIndex<=trueStatementIndex){
					simulationIndex+=-3;
				}
				else{
					if(simulationIndex==trueStatementIndex+1){
						simulationIndex+=-2;
					}
					else if(simulationIndex==endIfIndex){
						simulationIndex=trueStatementIndex;
					}
					else{
						simulationIndex=trueStatementIndex-1;
					}
				}
			}
    		simulatingBackwards=true;
    		clearSimulated();
    		simulateRun();
    	}
    });
    
    $("#btnCheckCode").on("click touchstart",function(){
    	checkCode();
    	handleContinuationButtons();
    });

    $("#btnShowSolution").on("click touchstart",function(){
    	if(promptID==promptToRemoveRedundancy){
    		showSolution(dontRequestConfirmation);
    	}
    	else{
    		showSolution(requestConfirmation);
    	}
    });
    
    $("#btnShiftLevel").on("click touchstart",function(){
    	generaliseProblem();
    });

    $("#btnInitialiseCode").on("click touchstart",function(){
    	//promptID=promptToShowRestOfSolution;
    	showPrompt();
    	resetStatements();
    	simulating=false;
    	simulatingBackwards=false;
    	resetSimulation();
    	handleContinuationButtons();
    });

    $("#btnEnter").on("click touchstart",function(){
		if(simulating)timerLoop=setInterval(function(){simulateRun();},simSpeed);
    });   
    
    /*$(".problemCases").click(function(){
    	if(parseInt(this.id.substr(4,1))%2==1){
    		$(this).addClass("caseSelectedOdd");
    	}
    	else{
    		$(this).addClass("caseSelectedEven");
    	}
    	var i=parseInt(this.id.substr(4,1));
    	$("#part"+i).show();
    	statements[i].move(codeLeftBorder,i*slotHeight+statementsTopBorder);
    	adjustCode();
    	
    	visibleCases=visibleCases | Math.pow(2,i);
    	advancePrompt();
    });*/
    
    $("#number-A").on("touchstart",function(){
    	$("#number-A").focus();
    });

    $("#number-A").bind("keyup mouseup",function(){
    	var newValue=parseInt($("#number-A").val());
    	if(newValue>=parseInt($("#number-A").attr("min")) && newValue<=parseInt($("#number-A").attr("max"))){
    		varValues[0]=newValue;
    	}
    	else{
    		$("#number-A").val(varValues[0]);
    	}
    	resetSimulation();
    	handleContinuationButtons();
    });

    /*$("#btnHint").click(function(){
		$("#number-A").val(hintValue[selectedSolution][0]);
		$("#number-B").val(hintValue[selectedSolution][1]);
    });*/
}

function handleMouseDown(){
	if(visibleCases==Math.pow(2,noOfCases)-1 && !simulating && divHoveringIndex>-1){
		divSrcIndex=parseInt(divHoveringIndex);
		xOffset=statements[divSrcIndex].left-mX;
		yOffset=statements[divSrcIndex].top-mY;
		statements[divSrcIndex].grab();
	}
}

function handleMouseUp(){
	if(divSrcIndex>-1){
		statements[divSrcIndex].release();
		//1. Αν ο χρήστης αποθέτει το statement εκτός των slots ή στο slot που βρισκόταν εξ αρχής, επιστροφή στην αρχική θέση
		if(divDestinationIndex==-1 || divSrcIndex==divDestinationIndex && statements[divSrcIndex].placed){
			//1.1. Το μετακινούμενο statement έχει ήδη τοποθετηθεί οπότε επιστρέφει στο slot που ήδη καταλάμβανε
			if(statements[divSrcIndex].placed){
				statements[divSrcIndex].setCol(0);
				statements[divSrcIndex].setRow(parseInt($("#"+statements[divSrcIndex].htmlID).attr("data-index")));
			}
			//1.2. Το μετακινούμενο statement δεν έχει τοποθετηθεί, οπότε επιστρέφει στην προσωρινή περιοχή πάνω αριστερά της οθόνης
			else{ 
				statements[divSrcIndex].move(xStart(divSrcIndex),yStart(divSrcIndex));
			}
		}
		//2. αλλιώς, αν το αποθέτει σε slot
		else{
			placeInSlot();
		}
		divHoveringIndex=-1;
		divSrcIndex=-1;
		divDestinationIndex=-1;
		zIndexRestore();
	}
}

function zIndexRestore(){
	for(var i=0;i<statements.length;i++){
		$("#"+statements[i].htmlID).zIndex(i+1);
	}
	$("#algorithmEnd").zIndex(i+1);
}

function allPlaced(){
	var placedCounter=0;
	for(var k=0;k<statements.length;k++){
		if(statements[k].placed)placedCounter++;
	}
	return placedCounter==noOfCases;
}

function placeInSlot(){
	statements[divSrcIndex].setCol(0);
	var statementOnTheMove=$.extend(true,{},statements[divSrcIndex]);//deep copy
	statementOnTheMove.setRow(parseInt(divDestinationIndex));
	$("#"+statementOnTheMove.htmlID).attr("data-index",divDestinationIndex);
	statementOnTheMove.placed=true;
	statements[divSrcIndex].placed=false;
	
	if(promptID!=promptToPlaceCases){
		//Αν γίνεται εναλλαγή θέσεων τακτοποίησε την τιμή κάθε data-index βάσει της αναδιάταξης...
		var newRow;
		if(divSrcIndex>divDestinationIndex){//σπρώξε προς τα κάτω
			for(var i=divSrcIndex-1;i>=divDestinationIndex;i--){
				newRow=statements[i].row+1;
				statements[i].setRow(newRow);
				$("#"+statements[i].htmlID).attr("data-index",newRow);
				statements[i+1]=statements[i];
			}
		}
		else if(divSrcIndex<divDestinationIndex){//σπρώξε προς τα πάνω
			for(var i=divSrcIndex+1;i<=divDestinationIndex;i++){
				newRow=statements[i].row-1;
				statements[i].setRow(newRow);
				$("#"+statements[i].htmlID).attr("data-index",newRow);
				statements[i-1]=statements[i];
			}
		}
	}
	else{
		var statementToUpdate=$.extend(true,{},statements[divDestinationIndex]);//deep copy
		///... διαφορετικά έλεγξε μήπως το μετακινούμενο statement αφήνεται σε κατειλημμένη θέση
		if(rowOccupied(divDestinationIndex)){//Αν ναι...
			var newRow;
			//...έλεγξε αν υπάρχει κενή θέση προς τα κάτω,
			var emptySlot=-1;
			i=divDestinationIndex+1;
			while(emptySlot==-1 && i<statements.length){						
				if(!statements[i].placed)emptySlot=i;
				i++;
			}
			if(emptySlot==-1){//...διαφορετικά...
				//βρες την κενή θέση που ΣΙΓΟΥΡΑ υπάρχει ψηλότερα και...
				i=divDestinationIndex-1;
				while(emptySlot==-1 && i>-1){						
					if(!statements[i].placed)emptySlot=i;
					i--;
				}
			}
			statementToUpdate=$.extend(true,{},statements[emptySlot]);//deep copy
			//statementToUpdate.setRow(divSrcIndex);
			$("#"+statementToUpdate.htmlID).attr("data-index",divSrcIndex);
			if(divDestinationIndex<emptySlot){//σπρώξε προς τα κάτω
				for(i=emptySlot-1;i>=divDestinationIndex;i--){
					newRow=statements[i].row+1;
					statements[i].setRow(newRow);
					$("#"+statements[i].htmlID).attr("data-index",newRow);
					statements[i+1]=statements[i];
				}						
			}
			else if(divDestinationIndex>emptySlot){
				//...σπρώξε προς τα πάνω.
				for(i=emptySlot+1;i<=divDestinationIndex;i++){
					newRow=statements[i].row-1;
					statements[i].setRow(newRow);
					$("#"+statements[i].htmlID).attr("data-index",newRow);
					statements[i-1]=statements[i];
				}
			}
		}
		if(!statementToUpdate.placed && statementToUpdate.htmlID!=statementOnTheMove.htmlID){
			$("#"+statementToUpdate.htmlID).attr("data-index",divSrcIndex);
			//statementToUpdate.setRow(divSrcIndex);
			statements[divSrcIndex]=$.extend(true,{},statementToUpdate);//deep copy
			//statements[divSrcIndex].placed=true;
		}
	}
	statements[divDestinationIndex]=$.extend(true,{},statementOnTheMove);//deep copy
	$("#"+statements[divDestinationIndex].htmlID).attr("data-index",divDestinationIndex);
	solutionType=userSolution;
	resetSimulation();
	handleContinuationButtons();
	if(allPlaced()){
		promptID=promptToFillInConditions;
	}
	showPrompt();
	adjustCode();
}

function rowOccupied(i){
	return statements[i].placed;
}

function handleMouseMove(){
	var i=0;
	var offset=$("#solutionArea").offset();
    /*mX=evt.pageX;
    mY=evt.pageY;*/
	if(divSrcIndex>-1){//μετατόπιση επιλεγμένου DIV
 		updateMovingDIV(statements[divSrcIndex]);
 		if(divDestinationIndex>-1){
 			$("#target"+divDestinationIndex).css("background-color","#f1f1f1");
 		}
 		divDestinationIndex=-1;
		if(promptID==promptToPlaceCases){//Αν δεν έχει ολοκληρωθεί η τοποθέτηση όλων των statements
			if(mX>codeLeftBorder && mY>statementsTopBorder && mY<noOfCases*slotHeight+statementsTopBorder){
				divDestinationIndex=parseInt((mY-statementsTopBorder)/slotHeight);
				$("#target"+divDestinationIndex).css("background-color","#d1d1d1");
			}
		}
		else{
	 		i=0;
	 	 	while(i<statements.length && divDestinationIndex==-1){
	 	 		if (statements[i].mouseHover(mX,mY) && i!=divSrcIndex){
	 	 			divDestinationIndex=i;
	 	 		}
	 	 		else{
	 	 			i++;
	 	 		}
	 	 	}			
		}
 	}
 	else {//έλεγχος θέσης ποντικιού ως προς τα DIVs (hovering)
 		divHoveringIndex=-1;
 		if(promptID<promptToRemoveConditionals){
 	 		for(i=0;i<statements.length;i++){
 				$("#case"+statements[i].htmlID.substr(4,1)).css({"background-color": "transparent"});
 	 		}
 	 		i=0;
 	 	 	while(i<statements.length && divHoveringIndex==-1){
 	 	 		if (statements[i].mouseHover(mX,mY)){
 	 	 			xOffset=statements[i].left-mX;
 	 	 			yOffset=statements[i].top-mY;
 	 	 			divHoveringIndex=i;
 	 				if(visibleCases==Math.pow(2,noOfCases)-1){
 	 					$("#case"+statements[divHoveringIndex].htmlID.substr(4,1)).css({"background-color": "PaleGoldenRod"});
 	 				}
 	 	 		}
 	 	 		else{
 	 	 			i++;
 	 	 		}
 	 	 	}
 		}
 	}
	if(debugMode) document.getElementById("debug").innerHTML="mX="+mX+" mY="+mY+" HoverIndex="+divHoveringIndex+" SourceIndex="+divSrcIndex+" DestinationIndex="+divDestinationIndex+" promptID="+promptID;
}

function handleMouseOut(){
	divHoveringIndex=-1;
}

function updateMovingDIV(statementOnTheMove){
	statementOnTheMove.move(mX+xOffset,mY+yOffset);
}

function defineConditionalsArray(){
	var page=0,col=0,row=0;
	$.each($(".movableDIV"),function(){
		var height=parseInt($(this).outerHeight());
		slotHeight=Math.max(slotHeight,height);
	});
	var i=0;
	$("#algorithmStart").css({left: codeLeftBorder, top: codeTopBorder});
	$("#promptArea").css({top: promptTopBorder});
	
	statementsTopBorder=parseInt($("#algorithmStart").outerHeight()+$("#algorithmStart").position().top);
	$.each($(".movableDIV"),function(){
		var htmlID=$(this).attr("id");
		var width=$(this).width();
		var left=$(this).position().left+codeLeftBorder;
		var top=i*slotHeight+statementsTopBorder;
		var newStatement=new statement(htmlID,codeLeftBorder,statementsTopBorder,left,top,row,col,width,slotHeight,page);
		statements.push(newStatement);
		$("#target"+i).css({top: top+"px", left: codeLeftBorder+"px"});
		$("#target"+i).width(width);
		$("#target"+i).height(slotHeight);
		row++;
		i++;
	});
	$("#algorithmEnd").css({left: codeLeftBorder, top: statementsTopBorder+noOfCases*slotHeight});
}

function adjustCode(){
	var majorIndex=0;
	var firstStatementVisible=false;
	var html="";
	var condition="";
	var msg="";
	var dataIndex=0;
	var startingClause="";
	
	var placedCounter=0;
	for(var k=0;k<statements.length;k++){
		if(statements[k].placed)placedCounter++;
	}
    html+="<code class='algorithm'><span id='algoStart'><span class='reservedWord'>ΑΛΓΟΡΙΘΜΟΣ</span> Τεταρτημόρια</span>";
    html+='\n  <span id="eisodos1"><span class="reservedWord">ΓΡΑΨΕ</span> "Δώσε τη γωνία:"</span>';
    html+="\n  <span id='eisodos2'><span class='reservedWord'>ΔΙΑΒΑΣΕ</span> θ</span>";
    //if(promptID==promptToRemoveRedundancy || promptID==promptToRemoveConditionals){
    if(promptID==promptToRemoveConditionals){
    	for(var ij=0;ij<statements.length;ij++){
    		$("#target"+ij).css("zIndex","-100");
    	}
        html+="\n  θ <- θ <span class='reservedWord'>MOD</span> 360";
    }
    if(promptID==promptNoConditionals){
        html+="\n  τετ <- θ <span class='reservedWord'>MOD</span> 360 <span class='reservedWord'>DIV</span> 90 + 1";
        html+='\n  <span class="reservedWord">ΓΡΑΨΕ</span> τετ, "ο τεταρτημόριο."';
        html+="\n<span class='reservedWord'>ΤΕΛΟΣ</span> Τεταρτημόρια";
    }
    html+="</code>";
    $("#algorithmStart").html(html);
    if(promptID<promptToResetProgram){
        for(var i=0;i<statements.length;i++){
    		html="";
    		startingClause="<span class='reservedWord'>ΑΝ</span>";
    		dataIndex=parseInt($("#"+statements[i].htmlID).attr("data-index"));
    		if(firstStatementVisible && dataIndex!=0 && statements[i].placed){
    			startingClause="<span class='reservedWord'>ΑΛΛΙΩΣ_ΑΝ</span>";
    		}
    		majorIndex=statements[i].htmlID.substr(4,1);
    		switch(statements[i].htmlID){
    		case "part0":
    			condition=generateEntryPlaceholder("statement0",userEntries[0],statements[i].placed);//,"θ < 90");//"θ<90";
    			msg='"1ο τεταρτημόριο."';
    			break;
    		case "part1":
    			condition=generateEntryPlaceholder("statement1",userEntries[1],statements[i].placed);//,"θ < 180");//"θ<180";
    			msg='"2ο τεταρτημόριο."';
    			break;
    		case "part2":
    			condition=generateEntryPlaceholder("statement2",userEntries[2],statements[i].placed);//,"θ < 270");//"θ<270";
    			msg='"3ο τεταρτημόριο."';
    			break;	
    		case "part3":
    			condition=generateEntryPlaceholder("statement3",userEntries[3],statements[i].placed);//,"θ < 360");//"θ<360";
    			msg='"4ο τεταρτημόριο."';
    			break;
    		}
    	    html+="<code class='statementCode'><span id='command"+majorIndex+"0'>";
    	    //βρες αν υπάρχει statement τοποθετημένο χαμηλότερσ 
    	    var lastPlaced=true;
    	    for(var ii=i+1;ii<noOfCases;ii++){
    	    	if(statements[ii].placed)lastPlaced=false;
    	    }
    		if(firstStatementVisible && suppressFinalCondition && lastPlaced && statements[i].placed){
    			html+="  <span class='reservedWord'>ΑΛΛΙΩΣ</span></span>";
    		}
    		else{
    		    html+="  "+startingClause + " "+condition+" <span class='reservedWord'>ΤΟΤΕ</span></span>";
    		}
    	    if(debugMode)html+="   <b>("+statements[i].htmlID+") dataIndex="+dataIndex+"</b>";
    	    html+="\n    <span id='command"+majorIndex+"1'><span class='reservedWord'>ΓΡΑΨΕ</span> "+msg+"</span>";
    	    html+="</code>";
    	    document.getElementById(statements[i].htmlID).innerHTML=html;

    		//if($("#"+statements[i].htmlID).is(":visible")){
    	    if(statements[i].placed){
    			firstStatementVisible=true;
    		}
        }
        html="<code class='algorithm'>  <span id='endIf'><span class='reservedWord'>ΤΕΛΟΣ_ΑΝ</span></span>";
        html+="\n<span id='algoEnd'><span class='reservedWord'>ΤΕΛΟΣ</span> Τεταρτημόρια</span>";
        $("#algorithmEnd").html(html);
        //Προσθήκη event παρακολούθησης εισόδου χρήστη σε κάθε editable τμήμα
        for(var statementIndex=0;statementIndex<noOfCases;statementIndex++){
        	if(document.getElementById("statement"+statementIndex)){
                document.getElementById("statement"+statementIndex).addEventListener("input", function() {
            	    saveUserEntry(this.id);
            	}, false);
        	}
        }
    }
}

function showProblem(){
	$("#problemWording").css({left: 0, top: codeTopBorder});
	$("#problemWording").html(getProblemWording());
}

function showStatements(){
	for(var i=0;i<statements.length;i++){
		$("#part"+i).show();
		statements[i].move(xStart(i),yStart(i));
	}
	//adjustCode();
	advancePrompt();
}

function xStart(i){
	return i*statements[i].width/2+i*horizontalBorder;
}

function yStart(i){
	//return yStart=promptTopBorder+$("#prompt").outerHeight()+2*verticalBorder+(i % 2)*(statements[i].height+verticalBorder);
	return 2*verticalBorder+(i % 2)*(statements[i].height+verticalBorder);
}

function getProblemWording(){
	var html="<p>Ο τριγωνομετρικός κύκλος χωρίζεται σε τέσσερα τεταρτημόρια";
	if(promptID>=promptSimplifySolution){
		html+=". Ορίζουμε ότι κάθε γωνία θ ανήκει σε εκείνο το τεταρτημόριο στο οποίο τερματίζεται το τόξο της.</p>";
		html+="<span class='problemCases caseSelectedEven' id='case0'>Έτσι, στο 1ο ανήκουν για παράδειγμα οι γωνίες 30&deg;, 370&deg; , 740&deg; κ.λπ. </span>";
		html+="<span class='problemCases caseSelectedOdd' id='case1'> Αντίστοιχα στο 2ο ανήκουν π.χ. οι γωνίες 90&deg;, 480&deg;, ...</span>";
		html+="<span class='problemCases caseSelectedEven' id='case2'> Ομοίως στο 3ο ανήκουν οι γωνίες 200&deg;, 540&deg; ...</span>";
		html+="<span class='problemCases caseSelectedOdd' id='case3'> Τέλος, στο 4ο τεταρτημόριο ανήκουν γωνίες όπως οι 300&deg;, 719&deg; κ.ο.κ. </span></p>";
		html+="<p>Να δημιουργήσετε αλγόριθμο ο οποίος θα διαβάζει το μέτρο μιας γωνίας στο διάστημα [0&deg;, +&infin;) και θα εμφανίζει το τεταρτημόριο στο οποίο ανήκει.</p>";
	}
	else{
		html+=":<p><span class='problemCases caseSelectedEven' id='case0'>Στο 1ο ανήκουν οι γωνίες με τιμή στο διάστημα [0&deg;, 90&deg;). </span>";
		html+="<span class='problemCases caseSelectedOdd' id='case1'>Οι γωνίες το μέτρο των οποίων ανήκει στο διάστημα [90&deg;, 180&deg;) εντάσσονται στο 2ο τεταρτημόριο.</span>";
		html+="<span class='problemCases caseSelectedEven' id='case2'> Ακολουθούν οι γωνίες που ανήκουν στο 3ο τεταρτημόριο δηλ. όσες ανήκουν στο [180&deg;, 270&deg;).</span>";
		html+="<span class='problemCases caseSelectedOdd' id='case3'> Τέλος, στο 4ο τεταρτημόριο ανήκουν οι γωνίες με τιμή στο [270&deg;, 360&deg;).</span></p>";
		html+="<p>Να δημιουργήσετε αλγόριθμο ο οποίος θα διαβάζει το μέτρο μιας γωνίας στο διάστημα [0&deg;, 360&deg;) και θα εμφανίζει το τεταρτημόριο όπου ανήκει.</p>";
	}
	return html;
}

function showButtonCaptions(){
	if(buttonCaptionsVisible){
        $("#btnCheckCode").html("Υποβολή");
        $("#btnShowSolution").html("Λύση");
        $("#btnInitialiseCode").html("Επαναφορά");
        $("#btnPlay").html("Έναρξη");
        $("#btnStop").html("Τερματισμός");
        $("#btnPause").html("Παύση");
        $("#btnContinue").html("Συνέχεια");
        $("#btnBackward").html("Πίσω");                 
        $("#btnForward").html("Μπροστά");
        /*$("#btnHint").html("Υπόδειξη");*/
 	}
	else{
        $("#btnCheckCode").html("");
        $("#btnShowSolution").html("");
        $("#btnInitialiseCode").html("");
        $("#btnPlay").html("");
        $("#btnStop").html("");
        $("#btnPause").html("");
        $("#btnContinue").html("");
        $("#btnBackward").html("");                 
        $("#btnForward").html("");
        /*$("#btnHint").html("");*/
	}
}

function advancePrompt(){
	switch(promptID){
	case promptToPlaceCases:
    	if(visibleCases==Math.pow(2,noOfCases)-1){
    		//promptID=promptToShowRestOfSolution;
    		$("#algorithmStart").show(animationRate);
    		$("#algorithmEnd").show(animationRate);
    	}
    	else{
    		additionalPrompt=true;
    	}
		showPrompt();
		break;
	case promptToShowRestOfSolution:
		break;
	case promptToSortCases:
		break;
	}
}

function showPrompt(){
	var msg="";
	switch(promptID){
	case promptToPlaceCases:
		msg="Για τη λύση του προβλήματος αυτού βλέπεις ήδη το βασικό σκελετό του αλγόριθμου και τα τμήματα της Δομής Επιλογής που αντιστοιχούν στις "+noOfCases+" περιπτώσεις (χωρίς τις συνθήκες).";
		msg+="<br>Τοποθέτησε τα τμήματα αυτά στις κενές θέσεις που θεωρείς κατάλληλες.";
		/*if(additionalPrompt){
			msg+="<br>Βλέπεις αμέσως τον αντίστοιχο κώδικα να συμπληρώνεται.";
		}*/
		break;
	case promptToFillInConditions:
		msg="Συμπλήρωσε στα κενά τις απαραίτητες συνθήκες για την ορθη λειτουργία του αλγόριθμου.";
		msg+=" Μπορείς να διαγράψεις τις τελείες, αλλά αυτό δεν είναι απαραίτητο.<br>";
		msg+="Μπορείς να διαχωρίσεις τα τμήματα της συνθήκης με κανένα, ένα ή περισσότερα κενά διαστήματα.";
		msg+=" Επίσης δεν έχει σημασία αν χρησιμοποιήσεις κεφαλαία ή πεζά γράμματα.<br>";
		msg+="Ακόμη, μπορείς να χρησιμοποιήσεις τους λογικούς τελεστές <code>ΟΧΙ</code>, <code>ΚΑΙ</code>, <code>Η</code> για να συνδυάσεις περισσότερες από μία συνθήκες.<br>";
		msg+="Τέλος, μπορείς να αναδιατάξεις τα τμήματα της Δομής Επιλογής, προκειμένου η λύση σου να έχει λιγότερες συνθήκες για έλεγχο και να φτάνει ταχύτερα σε αποτέλεσμα.<br>";
		break;
	case promptToSimulateCode:
		msg="Χρησιμοποίησε το κουμπί [Υποβολή] για να ελέγξεις την ορθότητα της πρότασής σου.<br>";
		msg+="Φυσικά μπορείς πάντα να ζητήσεις την αποκάλυψη της λύσης.<br>Μάλλον όμως είναι πιο ενδιαφέρον να δοκιμάσεις τις δικές σου δυνάμεις.";
		break;
	case promptToSortCases:
		if(errorsFound){
			msg="Η εκδοχή που προτείνεις δεν είναι σωστή.<br>";
			msg+="Δοκίμασε να αναδιατάξεις με το ποντίκι σου τις περιπτώσεις της πολλαπλής επιλογής για να εντοπίσεις μια σωστή λύση του προβλήματος.<br>";
			msg+="Ίσως σε βοηθήσει να κατανοήσεις τι πρόβλημα έχει ο κώδικας, αν παρακολουθήσεις την εκτέλεσή του με τα αντίστοιχα χειριστήρια,<br>φροντίζοντας να δώσεις <i>κατάλληλες</i> τιμές εισόδου ώστε να ελέγξεις όλες τις περιπτώσεις.";
		}
		else{
			if(optimalFound){
				if(solutionType==userSolution){
					msg="Πράγματι βρήκες μία λύση (και μάλιστα με το ελάχιστο δυνατό πλήθος συνθηκών) αλλά δεν είναι η μοναδική.<br>Μπορείς να εντοπίσεις εναλλακτικές; Θα χρειαστεί να αναδιατάξεις τα τμήματα της Δομής Επιλογής.";
				}
				else{
					msg="Αυτή που βλέπεις είναι μια λύση (και μάλιστα με το ελάχιστο δυνατό πλήθος συνθηκών) αλλά δεν είναι η μοναδική.<br>Μπορείς να εντοπίσεις εναλλακτικές; ";	
				}
			}
			else{
				if(solutionType==userSolution){
					msg="Πράγματι βρήκες μία λύση του προβλήματος.<br>Υπάρχουν όμως και παραλλαγές που ελέγχουν λιγότερες συνθήκες.<br>Για να τις εντοπίσεις δοκίμασε να αναδιατάξεις τα μέρη της πολλαπλής επιλογής.";
				}
				else{
					msg="Αυτή που βλέπεις είναι μία λύση του προβλήματος.<br>Υπάρχουν όμως και παραλλαγές που ελέγχουν λιγότερες συνθήκες.<br>Μπορείς να τις εντοπίσεις;";
				}
			}
			msg+="<br>Αν προτιμάς, μπορείς επίσης να δοκιμάσεις να λύσεις μια πληρέστερη μορφή του προβλήματος, πατώντας το κουμπί [Γενίκευση].";
		}
		break;
	case promptSimplifySolution:
		msg="Σε πρώτη εντύπωση φαίνεται ότι το γενικευμένο πρόβλημα έχει <i>άπειρες</i> περιπτώσεις ως προς τις τιμές της θ.<br>";
		msg+="Τα εναλλακτικά μηνύματα εξόδου συνεχίζουν πάντως να είναι τέσσερα.<br>";
		msg+="Πώς θα μπορέσεις να διαχειριστείς την κατάσταση;<br>";
		break;
	case promptToRemoveRedundancy:
		msg="Αν ο επαναλαμβανόμενος υπολογισμός του υπόλοιπου της διαίρεσης της θ με το 360 σου φαίνεται πλεονασμός, <b>έχεις δίκιο</b>.<br>";
		msg+="Πάτησε το κουμπί [Απλοποίηση], για να δεις μια πιο συνεπτυγμένη εκδοχή του αλγόριθμου.<br>";
		break;
	case promptToRemoveConditionals:
		msg="Τώρα που ξαναθυμήθηκες τους αριθμητικούς τελεστές της Ευκλείδιας Διαίρεσης, μήπως μπορείς να σκεφτείς ένα τρόπο για να λύσεις το πρόβλημα <b>χωρίς</b> Δομή Επιλογής;<br>";
		msg+="Αν δε μπορείς να τον σκεφτείς μόνος σου, πάτησε το κουμπί [Απλοποίηση] για να αποκαλυφθεί.<br>";
		break;
	case promptNoConditionals:
		msg="Βλέπεις λοιπόν ότι με επαρκή Ανάλυση ενός προβλήματος μπορείς να καταλήξεις σε μια πραγματικά απλή Λύση.";
		msg+="<br>Ένας αλγόριθμος μπορεί πάντα να επεκταθεί προς νέες περιπτώσεις. Για παράδειγμα θα μπορούσες να γενικεύσεις το συγκεκριμένο πρόβλημα και για αρνητικές γωνίες.";
		msg+="<br>Αν θεωρείς αρκετή την εμπειρία που αποκόμισες ως τώρα, προσπάθησε να λύσεις την εκδοχή αυτή μόνος σου.";
		break;
	}
    $("#prompt").html(msg);
}

function resetStatements(){
	var i,j,temp;
	//ταξινόμηση
	for(i=1;i<statements.length;i++){
		for(j=statements.length-1;j>=1;j--){
			if(statements[j].htmlID<statements[j-1].htmlID){
				temp=statements[j];
				statements[j]=statements[j-1];
				statements[j-1]=temp;
				$("#"+statements[j].htmlID).attr("data-index",j);
				$("#"+statements[j-1].htmlID).attr("data-index",j-1);
				statements[j].row=j;
				statements[j-1].row=j-1;
			}
		}
	}
	//εμφάνιση
	for(i=0;i<statements.length;i++){
		statements[i].move(codeLeftBorder,i*slotHeight+statementsTopBorder);
	}
	adjustCode();
}

function showSolution(confirmationSwitch){
	if(confirmationSwitch || confirm("Θέλεις σίγουρα να αποκαλύψεις μία λύση;")){
		var i,j,temp;
		var solutionToShow;
		resetSimulation();
		handleContinuationButtons();
		do{
			solutionToShow=parseInt(Math.random()*solutions.length);
		}while(selectedSolution==solutionToShow);
		selectedSolution=solutionToShow;
		for(j=0;j<noOfCases-1;j++){
			i=0;
			while(statements[i].htmlID!=solutions[selectedSolution][j]){
				i++;
			}
			temp=statements[j];
			statements[j]=statements[i];
			statements[i]=temp;
			$("#"+statements[j].htmlID).attr("data-index",j);
			$("#"+statements[i].htmlID).attr("data-index",i);
			statements[j].row=j;
			statements[i].row=i;
		}
		//Αναδιάταξη των DIVs που περιέχουν τις συνθήκες
		for(i=0;i<statements.length;i++){
			statements[i].move(codeLeftBorder,i*slotHeight+statementsTopBorder);
		}
		solutionType=officialSolution;
		errorsFound=false;
		adjustCode();
		//Συμπλήρωση συνθηκών
		for(i=0;i<statements.length-1;i++){
			$("#statement"+statements[i].htmlID.substr(4,1)).html(expressions[selectedSolution][i]);
		}
		optimalFound=selectedSolution<optimalLimit;
		if(promptID==promptSimplifySolution){
			promptID=promptToRemoveRedundancy;
			$("#btnShiftLevel").html("Απλοποίηση");
			$("#btnShiftLevel").show(animationRate);
		}
		/*else if(promptID==promptToRemoveRedundancy){
			promptID=promptToRemoveConditionals;
			$("#btnShiftLevel").html("Απλοποίηση");
			$("#btnShiftLevel").show(animationRate);
		}*/
		else if(promptID<promptSimplifySolution){
			promptID=promptToSortCases;
			$("#btnShiftLevel").prop("disabled",false);
			enableCodeSimulation();
		}
		showPrompt();
	}
	zIndexRestore();
}

function checkCode(){
	var solutionOK;
	var j=-1;
	do{
		j++;
		solutionOK=true;
		for(var i=0;i<noOfCases;i++){
			solutionOK=solutionOK && statements[i].htmlID==solutions[j][i];
			if(solutionOK && i<noOfCases-1){
				var officialExpr=trimSpaces(expressions[j][i].toLowerCase());
				var userExpr=trimSpaces(document.getElementById("statement"+statements[i].htmlID.substr(4,1)).textContent.toLowerCase());
				var officialAndPos=officialExpr.indexOf("και");
				//Αν η επίσημη λύση περιέχει ΚΑΙ...
				if(officialAndPos>-1){
					var userAndPos=userExpr.indexOf("και");
					//...και η λύση του χρήστη περιέχει τον ίδιο τελεστή...
					if(userAndPos>-1){
						//...απομόνωσε τις επί μέρους συνθήκες...
						var officialExpr1=officialExpr.substr(0,officialAndPos);
						var officialExpr2=officialExpr.substr(officialAndPos+3,officialExpr.length);
						var userExpr1=userExpr.substr(0,userAndPos);
						var userExpr2=userExpr.substr(userAndPos+3,userExpr.length);
						//... και έλεγξε όλους τους πιθανούς συνδυασμούς
						solutionOK=officialExpr1==userExpr1 && officialExpr2==userExpr2 || officialExpr1==userExpr2 && officialExpr2==userExpr1;
					}
					else{//... αν όμως η λύση του χρήστη δεν περιλαμβάνει ΚΑΙ η λύση είναι λάθος
						solutionOK=false;
					}
				}
				else{//Αν η επίσημη λύση δεν περιέχει ΚΑΙ έλεγξε την πλήρη ταύτιση
					solutionOK=solutionOK && userExpr==officialExpr;
				}
			}
			//solutionOK=solutionOK && statements[i].htmlID==solutions[j][i];
		}
	}while(j<solutions.length-1 && !solutionOK);
	if(solutionOK){
		errorsFound=false;
		if(debugMode)alert("Πολύ σωστά!");
		optimalFound=j<optimalLimit;
		$("#btnShiftLevel").prop("disabled",false);
		if(promptID==promptSimplifySolution){
			promptID=promptToRemoveRedundancy;
			$("#btnShiftLevel").html("Απλοποίηση");
			$("#btnShiftLevel").show(animationRate);
		}
		else if(promptID==promptToRemoveRedundancy){
			promptID=promptToRemoveConditionals;  //@@@
		}
	}
	else{
		errorsFound=true;
		if(debugMode)alert("Υπάρχουν λάθη...");
	}
	if(promptID<promptSimplifySolution){
		promptID=promptToSortCases;
	}
	showPrompt();
	enableCodeSimulation();
}

function enableCodeSimulation(){
	$("#simulateControls").show(animationRate);
	$("#dataInput").show(animationRate);
}

function simulateCode(simulationSwitch){
	if (simulationSwitch){
		//έναρξη προσομοίωση με κλήση timer
		timerLoop=setInterval(function(){simulateRun();},simSpeed);
	}
	else{
		clearInterval(timerLoop);
		simulatingBackwards=false;
		simulating=false;
    	$("#btnStop").hide();
    	$("#btnPlay").show();
    	$("#btnContinue").hide();
    	$("#btnPause").prop("disabled",true);
    	$("#btnPause").show();
    	handleContinuationButtons();
	}	
}

function simulateRun(){
	var statementIndex;
	simulationIndex++;
	handleContinuationButtons();
	//ΑΛΓΟΡΙΘΜΟΣ
	if(simulationIndex==0 || simulatingBackwards && simulationIndex>=0){
		$("#algoStart").addClass("simulatingCode");
	}
	else if(hideSimulationPath){
		$("#algoStart").removeClass("simulatingCode");
	}
	//ΕΙΣΟΔΟΣ-ΓΡΑΨΕ
	if(simulationIndex==1 || simulatingBackwards && simulationIndex>=1){
		$("#eisodos1").addClass("simulatingCode");
	}
	else if(hideSimulationPath){
		$("#eisodos1").removeClass("simulatingCode");
	}
	//ΕΙΣΟΔΟΣ-ΔΙΑΒΑΣΕ
	if(simulationIndex==2 || simulatingBackwards && simulationIndex>=2){
		$("#eisodos2").addClass("simulatingCode");
	}
	else if(hideSimulationPath){
		$("#eisodos2").removeClass("simulatingCode");
	}
	if(simulationIndex>=ifIndex && simulationIndex<=endIfIndex-1 || simulatingBackwards && simulationIndex>=ifIndex){

		var jj;
		var jjEnd=simulationIndex;
		var statementResult;
		for(jj=ifIndex;jj<=jjEnd;jj++){
			statementIndex=Math.round(jj/2)-2;
			
			var htmlID=parseInt(statements[statementIndex].htmlID.substr(4,1));
			var command="#command"+htmlID;

			
			if(jj % 2 == 1){//Προσομοίωση συνθήκης
			    $(command+"0").addClass("simulatingCode");
				$(command+"0").removeClass("conditionInError");
				//$("#statement"+htmlID).removeClass("conditionInError");
				statementResult=stripSimulateStatement(htmlID);
				if(statementResult=="error"){
					$(command+"0").addClass("conditionInError");
					//$("#statement"+htmlID).addClass("conditionInError");
					simulationIndex=-1;
			    	handleContinuationButtons();
				}
				else if(statementResult){
					$(command+"0").addClass("conditionTrue");
					//$("#statement"+htmlID).addClass("conditionTrue");
				}
				else{
					$(command+"0").addClass("conditionFalse");
					//$("#statement"+htmlID).addClass("conditionFalse");
					jj++;
				}
				if(statementResult!="error" && !simulatingBackwards){
					simulationIndex=jj;
				}
			}
			else{//Προσομοίωση εντολής
				$(command+"1").addClass("simulatingCode");
				jj=simulationIndex;
				if(!simulatingBackwards)simulationIndex=endIfIndex-1;//Σε περίπτωση ΑΛΗΘΟΥΣ συνθήκης προσπέρασε τις επόμενες εντολές μέχρι το ΤΕΛΟΣ_ΑΝ
			}
			
		}
	}
	//ΤΕΛΟΣ_ΑΝ
	if(simulationIndex==endIfIndex || simulatingBackwards && simulationIndex>=endIfIndex){
		$("#endIf").addClass("simulatingCode");
	}
	else if(hideSimulationPath){
		$("#endIf").removeClass("simulatingCode");
	}
	if(simulationIndex==endIfIndex+1 || simulatingBackwards && simulationIndex>=endIfIndex+1){
		$("#algoEnd").addClass("simulatingCode");
	}
	else if(hideSimulationPath){
		$("#algoEnd").removeClass("simulatingCode");
	}
	if(simulationIndex==endIfIndex+2 || simulatingBackwards && simulationIndex>=endIfIndex+2){//Μετά την προσομοίωση του ΤΕΛΟΣ, τερμάτισε το μηχανισμό προσομοίωσης
		simulateCode(false);	
	}
}

function handleContinuationButtons(){
	if(simulationIndex>endIfIndex){
		$("#btnForward").prop("disabled",true);
	}
	else{
		$("#btnForward").prop("disabled",false);
	}
	if(simulationIndex<0){
		$("#btnBackward").prop("disabled",true);
	}
	else{
		$("#btnBackward").prop("disabled",false);
	}
}

function stripSimulateStatement(statementIndex){
	var logicalResult=false;
	var command=document.getElementById("command"+statementIndex+"0").textContent;
	var ifIndex=command.indexOf("ΑΝ");
	var subCommand=command.substr(ifIndex+3,command.length-ifIndex-2);
	var condition=subCommand.substr(0,subCommand.indexOf("ΤΟΤΕ"));
	if(condition==""){//τμήμα ΑΛΛΙΩΣ
		logicalResult=true;
	}
	else{
		logicalResult=stringLogicalValue(condition,varNames,varValues);
	}
	return logicalResult;
}

function clearSimulated(){
	$(".simulatingCode").removeClass("simulatingCode");
	$(".conditionTrue").removeClass("conditionTrue");
	$(".conditionFalse").removeClass("conditionFalse");
	$(".conditionInError").removeClass("conditionInError");
}

function resetSimulation(){
	resetErrorMessages();
	clearSimulated();
	simulationIndex=-1;
}

function generateEntryPlaceholder(entryID,presetValue,editableState){
	var content="ˍˍˍ";
	var classToShow=(editableState && promptID<promptToResetProgram)?"class='toChange'":"";
	if(presetValue!== undefined)content=presetValue;
	var newEntry="<span "+classToShow+" id='"+entryID+"' contenteditable='"+(allPlaced() && promptID<promptToResetProgram)+"'>"+content+"</span>";
	return newEntry;
}

function saveUserEntry(entryID){
	entryIndex=parseInt(entryID.substr("statement".length,1));
	userEntries[entryIndex]=$("#"+entryID).html();
	var filledEntries=0;
	for(var i=0;i<userEntries.length;i++){
		if(userEntries[i]!=null)filledEntries++;
	}
	if(filledEntries>=3 && promptID<promptSimplifySolution){
		$("#solutionControls").show(animationRate);
		promptID=promptToSimulateCode;
		showPrompt();
	}
}

function generaliseProblem(){
	resetSimulation();
	handleContinuationButtons();
	//***************************************
	//* TO BE IMPLEMENTED IN FUTURE VERSION *
	//***************************************
	/*if(promptID==promptToResetProgram){
        $("#simulateControls").show(animationRate);
        $("#dataInput").show(animationRate);
        $("#btnCheckCode").show(animationRate);
        $("#btnInitialiseCode").show(animationRate);
        $("#showSolution").show(animationRate);
        $("#algorithmEnd").show(animationRate);
        $("#btnShiftLevel").show(animationRate);
        promptID=promptToPlaceCases;
        initialise();	    
	}*/
	if(promptID==promptToRemoveConditionals){
		$("#algorithmEnd").hide(animationRate);
		for(var i=0;i<noOfCases;i++){
			$("#part"+i).hide(animationRate);
		}
        promptID=promptNoConditionals;
		adjustCode();
		$("#solutionControls").hide(animationRate);
		//Η επόμεμη εντολή θα χρησιμοποιηθεί στην υλοποίηση της λειτουργίας επαναφοράς
		//$("#btnShowSolution").hide(animationRate);
	}
	else if(promptID==promptToRemoveRedundancy){
        promptID=promptToRemoveConditionals;
		adjustCode();
		generateSolutionExpressions();//επιστροφή στη λύση χωρίς MOD 360
		statementsTopBorder=parseInt($("#algorithmStart").outerHeight()+$("#algorithmStart").position().top);
		for(var i=0;i<noOfCases;i++){
			statements[i].setTop(i*slotHeight+statementsTopBorder);
		}
		$("#algorithmEnd").css({top: statementsTopBorder+noOfCases*slotHeight});
		promptTopBorder=codeTopBorder+$("#problemWording").outerHeight()+2*verticalBorder;
		$("#promptArea").css({top: promptTopBorder});
		showSolution(dontRequestConfirmation);
		$("#simulateControls").hide(animationRate);
		$("#dataInput").hide(animationRate);
		$("#btnCheckCode").hide(animationRate);
		$("#btnInitialiseCode").hide(animationRate);
	}
	else if(promptID==promptSimplifySolution){
		promptID=promptToRemoveRedundancy;
		adjustCode();
	}
	else{
		$("#number-A").attr({"max":1000000});
		promptID=promptSimplifySolution;
		generateSolutionExpressions();//γενίκευση λύσης με MOD 360
		showProblem();
		$("#btnShiftLevel").hide(animationRate);
	}
	showPrompt();
}